#include <stdio.h>
#include <stdlib.h>



/* expected input data format (two columns)                
/*                                            
/* col1: probablity values that need to be checked against something  
/*                                            
/* output data format
/*                                            
 * Line numbers corresponding to anamolies     
 */                                            

FILE *kf;

int main(int argc, char **argv) {
  FILE *df;
  FILE *of;
  char data[30];
  char pointer[50];
  float value, threshold;
  long m=0, f=0, c=0;
  int key_done = 0;
  long num = 0, found =0, min, max, caught=0, missed=0, false_alarms=0;
  
  if (argc != 5) {
    printf("Usage: %s src dest key_file threshold\n", argv[0]);
    exit(-1);
  }

  if (!(df = fopen (argv[1], "r"))) {
    printf ("fopen() failed\n");
    exit (1);
  }

  if (!(of = fopen (argv[2], "w"))) {
    printf ("fopen() failed\n");
    exit (1);
  }

  if (!(kf = fopen (argv[3], "r"))) {
    printf ("fopen() failed\n");
    exit (1);
  }
  
  threshold = atof(argv[4]);

  fscanf(kf, "%d %d\n", &min, &max);
  found = 0;
  key_done = 0;
  while (!feof(df)) {

    fscanf(df, "%f \n", &value);
    if(feof(df)){
      while(!feof(kf)){
	fscanf(kf, "%d %d\n", &min, &max);
	if (feof(kf))
	  break;
	fprintf(of, "%d r2 missed\n", min);
	m++;
      }
      break;
    }    
    num ++;
    if (value < threshold){
    loop: 
      if (key_done){
	fprintf(of, "%d r1 false_alarm\n", num);	
	f++;
	continue;
      }	
      if (num >= min && num <= (max)){
	fprintf(of, "%d r0 caught_it\n", num);
	if (!found)
	  c++;
	found = 1;
      }
      else if (num < min){
	fprintf(of, "%d r1 false_alarm\n", num);	
	f++;
      }
      else if (num > (max)){
	if (!found){
	  fprintf(of, "%d r2 missed\n", min);
	  m++;
	}
	else
	  found = 0;
	if (!feof(kf)){
	   fscanf(kf, "%d %d\n", &min, &max);
	   if (feof(kf)){
	     key_done = 1;
	   }
	   goto loop;
	}
	else 
	  continue;
      }
    }
  }

  printf("%f\t\t%d\t%d\t%d\tM+C=%d\n", threshold, m,c,f,m+c);
  fclose(df);
  fclose(of);
}

